//Libraries
#include "Keyboard.h"
#include <Adafruit_NeoPixel.h>

// Pin Defintions
const int TogglePin = A5;
const int ModePin = A4;
const int B1Pin = 4;
const int B2Pin = 5;
const int B3Pin = 6;
const int B4Pin = 7;
const int B5Pin = A0;
const int B6Pin = A1;
const int B7Pin = A2;
const int B8Pin = A3;

bool B1stat;
bool B2stat;
bool B3stat;
bool B4stat;
bool B5stat;
bool B6stat;
bool B7stat;
bool B8stat;

int brightness = 100;

unsigned long time;
unsigned long releasetime;

//Define NeoPixels
#define LED_PIN   2
#define LED_COUNT   6
Adafruit_NeoPixel strip(LED_COUNT, LED_PIN, NEO_GRB + NEO_KHZ800);

void setup() {
  // put your setup code here, to run once:
  Keyboard.begin();

  pinMode(TogglePin, INPUT);
  pinMode(TogglePin, INPUT);
  pinMode(B1Pin, INPUT);
  pinMode(B2Pin, INPUT);
  pinMode(B3Pin, INPUT);
  pinMode(B4Pin, INPUT);
  pinMode(B5Pin, INPUT);
  pinMode(B6Pin, INPUT);
  pinMode(B7Pin, INPUT);
  pinMode(B8Pin, INPUT);

  strip.begin();           // INITIALIZE NeoPixel strip object (REQUIRED)
  strip.show();            // Turn OFF all pixels ASAP
  strip.setBrightness(brightness); // Set BRIGHTNESS (max = 255)
  for (int n=0; n<7; n++){
    strip.setPixelColor(n, 255, 255, 255);
  }
  strip.show();
}


void loop() {
  // put your main code here, to run repeatedly:
  if (digitalRead(B1Pin) == 1){
    Serial.println("1");
    if (B1stat == 0){
      B1stat = 1;
      Keyboard.write(97);
      setColor(1);
      releasetime = millis() + 500;
    }
  }
  if (digitalRead(B1Pin) == 0){
    B1stat = 0;
   }
  if (digitalRead(B2Pin) == 1){
    Serial.println("2");
  }
  if (digitalRead(B3Pin) == 1){
    Serial.println("3");
    if (B3stat == 0){
      B3stat = 1;
      Keyboard.write(107);
      setColor(4);
      releasetime = millis() + 500;
    }
  }
  if (digitalRead(B3Pin) == 0){
    B3stat = 0;
   }
  if (digitalRead(B4Pin) == 1){
    Serial.println("4");
    brightness++;
  }
  if (digitalRead(B5Pin) == 1){
    Serial.println("5");
    if (B5stat == 0){
      B5stat = 1;
      Keyboard.write(122);
      setColor(2);
      releasetime = millis() + 500;
    }
  }
  if (digitalRead(B5Pin) == 0){
    B5stat = 0;
   }
  if (digitalRead(B6Pin) == 1){
    Serial.println("6");
    if (B6stat == 0){
      B6stat = 1;
      Keyboard.write(120);
      setColor(4);
      releasetime = millis() + 500;
    }
  }
  if (digitalRead(B6Pin) == 0){
    B6stat = 0;
   }
  if (digitalRead(B7Pin) == 1){
    Serial.println("7");
    if (B7stat == 0){
      B7stat = 1;
      Keyboard.write(106);
      setColor(4);
      releasetime = millis() + 500;
    }
  }
  if (digitalRead(B7Pin) == 0){
    B7stat = 0;
   }
  if (digitalRead(B8Pin) == 1){
    Serial.println("8");
    brightness--;
  }
  if (brightness > 255){
    brightness = 255;
  }
  if (brightness < 10){
    brightness = 10;
  }

  time = millis();

  if (time >= releasetime){
    setColor(0);
  }
  
  delay(1);
  
  Serial.println(brightness);
  strip.setBrightness(brightness);
  strip.show();
}

void setColor(int color){
  //Sets the color of the NeoPixels based on the following:
  //Number - RGB - Color
  //0 - 255, 255, 255 - White
  //1 - 255, 69, 0 - OrangeRed Upvote
  //2 - 120, 148, 252 - Cyan Downvote
  //3 - 247, 105, 2 - RIT Orange
  //4 - not yet implemented
  int red = 255;
  int green = 255;
  int blue = 255;
  if (color == 1){
    red = 255;
    green = 69;
    blue = 0;
  }
  if (color == 2){
    red = 120;
    green = 148;
    blue = 252;
  }
  if (color == 3){
    red = 247;
    green = 105;
    blue = 2;
  }
  for (int n=0; n<7; n++){
  strip.setPixelColor(n, red, green, blue);
  }
}
